<?php
/**********************************************************************
 * ProxmoxVPS developed. (26.03.19)
 * *
 *
 *  CREATED BY MODULESGARDEN       ->       http://modulesgarden.com
 *  CONTACT                        ->       contact@modulesgarden.com
 *
 *
 * This software is furnished under a license and may be used and copied
 * only  in  accordance  with  the  terms  of such  license and with the
 * inclusion of the above copyright notice.  This software  or any other
 * copies thereof may not be provided or otherwise made available to any
 * other person.  No title to and  ownership of the  software is  hereby
 * transferred.
 *
 *
 **********************************************************************/

namespace ModulesGarden\Servers\ProxmoxVps\App\Http\Actions;

use MGProvision\Proxmox\v2\models\Kvm;
use MGProvision\Proxmox\v2\models\User;
use ModulesGarden\ProxmoxAddon\App\Services\ApiService;
use ModulesGarden\ProxmoxAddon\App\Services\Vps\ProductService;
use ModulesGarden\ProxmoxAddon\App\Services\Vps\UserService;
use ModulesGarden\Servers\ProxmoxVps\App\Helpers\AppParams;
use ModulesGarden\Servers\ProxmoxVps\App\Helpers\ProxmoxAddonValidator;
use ModulesGarden\Servers\ProxmoxVps\Core\App\Controllers\Instances\AddonController;
use ModulesGarden\Servers\ProxmoxVps\Core\UI\Traits\WhmcsParams;

class SuspendAccount extends AddonController
{
    use ProductService;
    use ApiService;
    use UserService;
    use WhmcsParams;

    public function execute($params = null)
    {
        if(!ProxmoxAddonValidator::isInstalled()){
            return ProxmoxAddonValidator::failAsString();
        }
        (new AppParams())->initFromWhmcsParams();
        try
        {
            //User suspend
            $user        = $this->getUser();
            $userService = new User("{$user->username}@{$user->realm}");
            $userService->setApi($this->api());
            $permissions = $userService->permissions();
            $vmid        = $params['customfields']['vmid'];
            foreach ($permissions as $p)
            {
                if ($p['path'] == "/vms/" . $vmid && $p['ugid'] == $userService->getUserid())
                {
                    $userService->updatePermission($vmid, $p['roleid'], 1);
                }
            }
            if ($user->hosting_id > 0)
            {
                $userService->disable();
            }
            //VM suspend
            $this->vm()->updateConfig(["onboot" => 0]);
            if (!$this->vm()->isRunning())
            {
                return "success";
            }
            $suspensionAction = $this->configuration()->getSuspensionAction();
            if ($suspensionAction && method_exists($this->vm(), $suspensionAction))
            {
                $this->vm()->{$suspensionAction}();
                return "success";
            }
            if ($this->vm() instanceof Kvm)
            {
                $this->vm()->suspend();
                return "success";
            }
            if ($this->vm()->isRunning())
            {
                $this->vm()->stop();
            }
            return "success";
        }
        catch (\Exception $ex)
        {
            return $ex->getMessage();
        }
    }
}